/*===============================================================
 * Project: libferit
 * Author : Terry 'Mongoose' Hendrix
 * Website: http://www.westga.edu/~stu7440/
 * Email  : stu7440@westga.edu
 * Object : 
 * Comment: 
 *
 *-- History -----------------------------------------------
 *
 * See source file.
 *
 ==============================================================*/

#ifndef __MONGOOSE_LIBFERIT_GNUTELLA_H
#define __MONGOOSE_LIBFERIT_GNUTELLA_H

#include "TcpProtocol.h"

typedef struct host_s
{
  unsigned char ip[4];
  unsigned short port;
  int files;
  int files_sz;

  struct host_s *next;

} host_t;

class Gnutella : public TcpProtocol
{
public:

   Gnutella(int timeout);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : 
    * Post     : 
    -------------------------------------------*/


   ~Gnutella();
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : 
    * Post     : 
    -------------------------------------------*/


   void Ping(int socket);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is valid
    * Post     : Sends gnutella ping over socket
    -------------------------------------------*/


   void Pong(int socket);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is valid
    * Post     : Sends gnutella pong over socket
    *            ( ping reply )
    -------------------------------------------*/


   void Query(int socket, char *query, int min_speed);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is valid
    *            query is a query string
    *            min_speed is minium connection
    *            speed server filter
    * Post     : Sends gnutella query over socket
    -------------------------------------------*/


   int Auth(int socket);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is valid
    * Post     : Sets up connection to server
    -------------------------------------------*/


   int Download(Url *url, char *filename);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : url is a valid Url object
    *            filename is query string
    * Post     : Gnutella object queries and
    *            attempts d/l of query
    -------------------------------------------*/

private:

   int PacketHandler(int socket);
   /*-------------------------------------------
    * Created  : 2000 12 25 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is valid
    * Post     : Gnutella object tries to use
    *            the open socket to find more 
    *            hosts or monitor and query hosts
    -------------------------------------------*/



   host_t *_hosts;                /* Host cache */
};

#endif




	
