/*===============================================================
 * Project: libferit
 * Author : Terry 'Mongoose' Hendrix
 * Website: http://www.westga.edu/~stu7440/
 * Email  : stu7440@westga.edu
 * Object : Http
 * Comment: Http module.
 *
 *-- History -----------------------------------------------
 *
 * See source file.
 *
 ==============================================================*/

#ifndef __MONGOOSE_LIBSFERIT_HTTP_H
#define __MONGOOSE_LIBSFERIT_HTTP_H

#include "TcpProtocol.h"

#define REDIRECT_MAX 15

#define USER_AGENT "ferit/0.0.8 (http://www.westga.edu/~stu7440/projects)"
#define SNARF_USER_AGENT "snarf/2.0 (http://www.xach.com/snarf)"
#define NETSCAPE_USER_AGENT "Mozilla/4.0 (X11; Unix; Hi-mom)"
#define MOZILLA_USER_AGENT "Mozilla/5.0 (X11; U; Linux 2.5.1 i786; en-US; 0.7)"
#define MSIE_USER_AGENT "Mozilla/4.0 (Compatible; MSIE 4.0)"

class Http : public TcpProtocol
{
public:

   Http(int timeout);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   virtual ~Http();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Download(Url *url, char *filename);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   char *GetHeaderValue(char *header, const char *full_header);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   char *GetHeader(int fd);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Request(int socket, Url *url);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Message(int socket, const char *s, ...);
   int BufferMessage(char **s, const char *s, ...);

 private:

   int _redirect_count;             /* Number of redirects followed */
};

#endif




	
