/*===============================================================
 * Project: libferit ( base netcode from Snarf 2.0 )
 * Author : Terry 'Mongoose' Hendrix
 * Website: http://www.westga.edu/~stu7440/
 * Email  : stu7440@westga.edu
 * Object : Progress
 * Comment: Progress module.
 *
 *-- History -----------------------------------------------
 *
 * See source file.
 *
 ==============================================================*/

#ifndef __MONGOOSE_LIBSNARF_PROGRESS_H
#define __MONGOOSE_LIBSNARF_PROGRESS_H

#include "Url.h"

class Progress
{
private:

   bool _tty;	                  /* If tty allocated, true */

   long int _length;	          /* Total length */

   long int _current;	          /* Current position */

   long int _offset;	          /* If resuming, save the offset */

   int _overflow;	          /* Save the remainder */	

   int _max_hashes;               /* Max number of hashes to print */

   int _cur_hashes;	          /* Total hashes printed so far*/

   Url *_url;                     /* Url being fetched */

   unsigned char _frame;          /* Animation frame */

   char *_outfile;                /* Output filename */

   double _start_time;	          /* For calculating k/sec */


public:

   Progress();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   ~Progress();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Winsize();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   double Time();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Init(Url *url, long int len);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   void Update(long int increment);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   void Offset(long int n);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/
};

#endif




	
