/*===============================================================
 * Project: libferit
 * Author : Terry 'Mongoose' Hendrix
 * Website: http://www.westga.edu/~stu7440/
 * Email  : stu7440@westga.edu
 * Object : Spider
 * Comment: This is the spider module of the goosehunt.
 * 
 *-- History -----------------------------------------------
 *
 * 1999-08-18:
 * Mongoose - Created, based on prototype done in ANSI C
 ==============================================================*/

#ifndef __MONGOOSE_GOOSEHUNT_SPIDER_H
#define __MONGOOSE_GOOSEHUNT_SPIDER_H

extern char *VERSION;
extern char *CACHE_PATH;
extern char *DATA_PATH;
extern char *PROXY_URL;
extern int   SLEEP_TIME;
extern int   MAX_PAGES;
extern int   MAX_BRANCHES;

void shutdown_goosehunt();

enum spider_query_type
{
   LYCOS_MP3 = 64
};

class Spider
{
private:

    bool _tagged;

    int Cache(char *key, char *tmp);
    /*----------------------------------------------
     * Created  : 990818 by Terry Hendrix II
     * Modified : NA
     * Pre      : key is valid cache file filename
     *            tmp is valid tmp cache file filename
     * Post     : tmp is added to cache
      ---------------------------------------------*/

    void Handle(int err, char *url, char *filename);
    /*----------------------------------------------
     * Created  : 990818 by Terry Hendrix II
     * Modified : NA
     * Pre      : err is valid error for url
     *            filename is file to save as
     * Post     : Fault tolerance|correction is used
      ---------------------------------------------*/

    void QueryPage(char *filename, char *name, int page, char *key);
    /*----------------------------------------------
     * Created  : 990818 by Terry Hendrix II
     * Modified : NA
     * Pre      : 
     * Post     : 
      ---------------------------------------------*/

    void QueryNextPage(char *lnkfile, char *name, int page, char *key);
    /*----------------------------------------------
     * Created  : 990818 by Terry Hendrix II
     * Modified : NA
     * Pre      : 
     * Post     : 
      ---------------------------------------------*/

public:

    Spider();
    /*----------------------------------------------
     * Created  : 990818 by Terry Hendrix II
     * Modified : NA
     * Pre      : None
     * Post     : Spider object is made
      ---------------------------------------------*/

    ~Spider();
    /*-----------------------------------------
     * Created  : 990609 by Terry Hendrix II
     * Modified : NA
     * Pre      : Spider object to delete
     * Post     : Spider object is deleted
      -----------------------------------------*/

    int Get(char *url_string, char *filename);
    /*-----------------------------------------
     * Created  : 990609 by Terry Hendrix II
     * Modified : NA
     * Pre      : url_string is a valid url
     *            filename is a valid filename
     * Post     : url is saved as filename via
     *            network transfer 
      -----------------------------------------*/

    int Query(char *query, int type);
    /*-----------------------------------------
     * Created  : 990609 by Terry Hendrix II
     * Modified : NA
     * Pre      : query is a string usable
     *            at the used search engine
     *            type is valid query flag
     * Post     : A cache file for that query is 
     *            made via network transfer and
     *            lots of parsing
      -----------------------------------------*/

    void Fetch(char *key);
    /*-----------------------------------------
     * Created  : 990609 by Terry Hendrix II
     * Modified : NA
     * Pre      : key is a valid cache file
     *            filename
     * Post     : Every url in cache is saved 
     *            as a file via network transfer
      -----------------------------------------*/
};

#endif


