/*===============================================================
 * Project: libferit
 * Author : Terry 'Mongoose' Hendrix
 * Website: http://www.westga.edu/~stu7440/
 * Email  : stu7440@westga.edu
 * Object : TcpProtocol
 * Comment: TCP wrapper class
 *
 *-- History -----------------------------------------------
 *
 * See source file.
 *
 ==============================================================*/

#ifndef __MONGOOSE_LIBFERIT_COMMON_H
#define __MONGOOSE_LIBFERIT_COMMON_H

#include "Url.h"
#include "utils.h"

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdarg.h>
#include <netdb.h>

#ifdef USE_SOCKS5
#define SOCKS
#include <socks.h>
#endif


class TcpProtocol
{
public:

   TcpProtocol(int timeout);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   virtual ~TcpProtocol();
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/
   
   int SaveStream(int socket, Url *url);
   /*-------------------------------------------
    * Created  : 2001.01.10 by Terry Hendrix II
    * Modified : 
    * Pre      : socket is open
    *            url is valid
    * Post     : File is saved from socket
    *            as described by url, and waits
    *            'timeout' seconds for data
    -------------------------------------------*/

   int PrintStream(int socket, Url *url);

   void Timeout(int timeout);
   /*-------------------------------------------
    * Created  : 2001.01.13 by Terry Hendrix II
    * Modified : 
    * Pre      : timeout isn't negative
    * Post     : Set timeout 
    -------------------------------------------*/

   virtual int Download(Url *url, char *filename) = 0;
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int Connect(char *remote_host, int port);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   void DisableClose();

private:

   int SaveData(Url *url, int sock, FILE *out);
   /*-------------------------------------------
    * Created  : 2000 01 23 by Terry Hendrix II
    * Modified : NA
    * Pre      : 
    * Post     : 
    -------------------------------------------*/

   int _timeout;        /* Amount of time to wait for data over socket */
   
   bool _close;         /* If false disables closing socket in this class */
};

#endif



