/* -*- Mode: C++; tab-width: 3; indent-tabs-mode: t; c-basic-offset: 3 -*- */
/*================================================================
 * 
 * Project : mtk
 * Author  : Terry 'Mongoose' Hendrix II
 * Website : http://www.westga.edu/~stu7440/
 * Email   : stu7440@westga.edu
 * Object  : 
 * License : No use w/o permission (C) 2001 Mongoose
 * Comments: C string utils for C++
 *
 *
 *           This file was generated using Mongoose's C++ 
 *           template generator script.  <stu7440@westga.edu>
 * 
 *-- History ------------------------------------------------- 
 *
 * 2001.06.30:
 * Mongoose - Created
 =================================================================*/

#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>


char tolower(char c)
{
  /* Convert uppercase to lowercase */
  if (c > 64 && c < 91)
    c += 32;

  return c;
}


char *strlowercase(char *string)
{
   char *start = string;


   if (string == NULL)
      return NULL;

   while(*string) 
   {
      *string = tolower(*string);
      string++;
   }

   return start;
}


/* Taken from glib? */
char *strconcat(const char *string1, ...)
{
   unsigned int l;
   va_list args;
   char   *s;
   char   *concat;

  
   l = 1 + strlen(string1);
   va_start(args, string1);
   s = va_arg(args, char *);

   while (s) 
   {
      l += strlen(s);
      s = va_arg(args, char *);
   }
        
   va_end (args);
  
   concat = new char[l];
   concat[0] = 0;
  
   strcat (concat, string1);
   va_start (args, string1);
   s = va_arg (args, char *);

   while (s) 
   {
      strcat(concat, s);
      s = va_arg(args, char *);
   }
   
   va_end (args);
       
   return concat;
}


char *strdup(char *src)
{
   char *dest = NULL;


   if (!src || !src[0])
      return NULL;

   dest = new char[strlen(src) + 1];
   strcpy(dest, src);

   return dest;
}


int strncasecmp(char *s0, char *s1, int depth)
{
   for(; caseless_charcmp(*s, *t); s++, t++)
      if (*s == '\0' && *t == '\0')
         return 0;
 
   return *s - *t;
}


int caseless_charcmp(char c, char d)
{
   if (c > 64 && c < 91)
      c += 32;

   if (d > 64 && d < 91)
      d += 32; 

   return (c == d);
}


int caseless_strcmp(char *s, char *t)
{
   for(; caseless_charcmp(*s, *t); s++, t++)
      if (*s == '\0')
         return 0;
 
   return *s - *t;
}


int compare(char *s0, char *s1)
{
   int  len0, len1;
   char swap;
   int  ret;

   
   if (!s0 || !s1)
      return -1; 

   len0 = strlen(s0);
   len1 = strlen(s1);

#ifdef OBSOLETE
   if (len1 <= len0)
   {
      swap = s0[len1];
      s0[len1] = 0;
      
      ret = caseless_strcmp(s0, s1);
      s0[len1] = swap;
   }
   else
   {
      swap = s1[len0];
      s1[len0] = 0;
      
      ret = caseless_strcmp(s1, s0);
      s1[len0] = swap;
   }
#else
#ifdef HAVE_STRNCASECMP
   ret = (len1 <= len0)?strncasecmp(s0,s1,len1):strncasecmp(s0,s1,len0);
#else
   char* copy0 = new char[len0+1];
   char* copy1 = new char[len1+1];
   strcpy(copy0,s0);
   strcpy(copy1,s1);
  
   if (len1 <= len0)
   {
      swap = copy0[len1];
      copy0[len1] = 0;
      
      ret = caseless_strcmp(copy0, copy1);
      copy0[len1] = swap;
   }
   else
   {
      swap = copy1[len0];
      copy1[len0] = 0;
      
      ret = caseless_strcmp(copy1, copy0);
      copy1[len0] = swap;
   }
#endif
#endif

   return (ret == 0);
}


char *posix_filename(char *old_filename)
{
   char c;
   int i = 0, j = 0, length = strlen(old_filename);
   char *filename = new char[length];
   
   
   for (i = 0; i < length; i++)
   {
      c = old_filename[i];

      // Trim off unwanted leading chars, which are otherwise valid
      if (j == 0)
      {
	switch (c)
	{
	case '-':
	case '.':
	  i++;
	  break;
      }

      /* Remove special characters and try to make name follow:
       * Word-Word_Word.ext style
       */
      switch (c)
      {
      case '=':  case ',':  case '|':
      case '*':  case '/':  case '\\':
      case '$':  case '@':  case '!':
      case '^':  case '+':  case '~':
      case '`':  case ';':  case '"':
      case '(':  case '?':  case ':':
      case '&':  case '[':  case ']':
      case ')':  case '{':  case '}':
	break;
      case ' ':
	// Replace blanks

	filename[j++] = '_'; 
	break;
      case '-':
	// Condense [-]+ patterns

	if (j > 0 && (filename[j - 1] == '_' || filename[j - 1] == '-'))
	  filename[j - 1] = '-';
	else
	  filename[j++] = '-';
	break;
      case '%':
	// Try some common uuencode repacements here

           if (i + 1 < length && old_filename[i + 1] == '2')
	   {
              i++;

              if (i + 1 < length && old_filename[i + 1] == '0')
	      {
                 i++;

                 if (j > 0 && filename[j -1] != '_' && filename[j - 1] != '-') 
                    filename[j++] = '_';
	      }
	   }

         break;
      default:
         filename[j++] = c;
      }
   }

   filename[j] = 0;

   return filename;
}
