#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>


//FIXME: ugly
/* Written by lauri alanko, C++ fixes Mongoose */
char *base64(char *bin, int len)
{
   char *buf = new char [((len+2)/3*4+1)];
   int i = 0, j = 0;
   char BASE64_END = '=';
   char base64_table[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" 
                         "abcdefghijklmnopqrstuvwxyz"
                         "0123456789+/";
	
   while( j < len - 2 ) 
   {
      buf[i++]=base64_table[bin[j]>>2];
      buf[i++]=base64_table[((bin[j]&3)<<4)|(bin[j+1]>>4)];
      buf[i++]=base64_table[((bin[j+1]&15)<<2)|(bin[j+2]>>6)];
      buf[i++]=base64_table[bin[j+2]&63];
      j+=3;
   }

   switch ( len - j ) 
   {
   case 1:
      buf[i++] = base64_table[bin[j]>>2];
      buf[i++] = base64_table[(bin[j]&3)<<4];
      buf[i++] = BASE64_END;
      buf[i++] = BASE64_END;
      break;
   case 2:
      buf[i++] = base64_table[bin[j] >> 2];
      buf[i++] = base64_table[((bin[j] & 3) << 4) 
                              | (bin[j + 1] >> 4)];
      buf[i++] = base64_table[(bin[j + 1] & 15) << 2];
      buf[i++] = BASE64_END;
      break;
   case 0:
      break;
   }
	
   buf[i]='\0';
   return buf;
}

char *string_lowercase(char *string)
{
   char *start = string;


   if (string == NULL)
      return NULL;

   while(*string) 
   {
      *string = tolower(*string);
      string++;
   }

   return start;
}

off_t get_file_size(const char *file)
{
   struct stat file_info;

   if (!(file || *file) )
      return 0;

   if (file[0] == '-' )
      return 0;

   if (stat(file, &file_info) == -1)
      return 0;
        else
                
   return(file_info.st_size);
}

/* Taken from glib */
char *strconcat(const char *string1, ...)
{
   unsigned int l;
   va_list args;
   char   *s;
   char   *concat;
  
   l = 1 + strlen(string1);
   va_start(args, string1);
   s = va_arg(args, char *);

   while (s) 
   {
      l += strlen(s);
      s = va_arg(args, char *);
   }
        
   va_end (args);
  
   concat = new char[l];
   concat[0] = 0;
  
   strcat (concat, string1);
   va_start (args, string1);
   s = va_arg (args, char *);

   while (s) 
   {
      strcat(concat, s);
      s = va_arg(args, char *);
   }
   
   va_end (args);
       
   return concat;
}

char *mon_strdup(char *src)
{
   char *dest = NULL;

   if (src == NULL)
      return NULL;

   dest = new char[strlen(src) + 1];
   strcpy(dest, src);

   return dest;
}


int caseless_charcmp(char c, char d)
{
   if (c > 64 && c < 91)
      c += 32;

   if (d > 64 && d < 91)
      d += 32; 

   return (c == d);
}

int caseless_strcmp(char *s, char *t)
{
   for(; caseless_charcmp(*s, *t); s++, t++)
      if (*s == '\0')
         return 0;
 
   return *s - *t;
}

int compare(char *s0, char *s1)
{
   int  len0, len1;
   char swap;
   int  ret;

   
   if (!s0 || !s1)
      return -1; 

   len0 = strlen(s0);
   len1 = strlen(s1);

#ifdef OBSOLETE
   if (len1 <= len0)
   {
      swap = s0[len1];
      s0[len1] = 0;
      
      ret = caseless_strcmp(s0, s1);
      s0[len1] = swap;
   }
   else
   {
      swap = s1[len0];
      s1[len0] = 0;
      
      ret = caseless_strcmp(s1, s0);
      s1[len0] = swap;
   }
#else
#ifdef HAVE_STRNCASECMP
   ret = (len1 <= len0)?strncasecmp(s0,s1,len1):strncasecmp(s0,s1,len0);
#else
   char* copy0 = new char[len0+1];
   char* copy1 = new char[len1+1];
   strcpy(copy0,s0);
   strcpy(copy1,s1);
  
   if (len1 <= len0)
   {
      swap = copy0[len1];
      copy0[len1] = 0;
      
      ret = caseless_strcmp(copy0, copy1);
      copy0[len1] = swap;
   }
   else
   {
      swap = copy1[len0];
      copy1[len0] = 0;
      
      ret = caseless_strcmp(copy1, copy0);
      copy1[len0] = swap;
   }
#endif
#endif

   return (ret == 0);
}

char *clean_filename(char *old_filename)
{
   char c;
   int i = 0, j = 0, length = strlen(old_filename);
   char *filename = new char[length];
   
   
   for(i = 0; i < length; i++)
   {
      c = old_filename[i];


      /* Convert uppercase to lowercase */
      if (c > 64 && c < 91)
            c += 32;

      /* Capitialize first letter of each word in title */
      if (j == 0 || (j > 0 && (filename[j - 1] == '-' || 
          filename[j - 1] == '_')))
         if (c > 96 && c < 123)
            c -= 32;


      /* Remove special characters and try to make name follow:
         Word-Word_Word.ext style */
      switch(c)
      {
      case '=':  case ',':  case '|':
      case '*':  case '/':  case '\\':
      case '$':  case '@':  case '!':
      case '^':  case '+':  case '~':
      case '`':  case ';':  case '"':
      case '(':  case '?':  case ':':
      case '&':  case '[':  case ']':
      case ')':  case '{':  case '}':
         break;
      case ' ':
         filename[j++] = '_';
         break;
      case '-':
           if (j > 0 && (filename[j - 1] == '_' || filename[j - 1] == '-'))
               filename[j - 1] = '-';
           else
               filename[j++] = '-';
           break;
      case '%':
           if (i + 1 < length && old_filename[i + 1] == '2')
	   {
              i++;

              if (i + 1 < length && old_filename[i + 1] == '0')
	      {
                 i++;

                 if (j > 0 && filename[j -1] != '_' && filename[j - 1] != '-') 
                    filename[j++] = '_';
	      }
	   }

         break;
      default:
         filename[j++] = c;
      }
   }

   filename[j] = 0;

   return filename;
}
